# typefaces
# ---------
# The "typeface name" is the name Word will display when you list the fonts.

# The "LJ nbr" is the typeface code the LaserJet uses to identify the
# typeface.  (This is the number in the font header in the font file itself.)

# The "symbolset" specifies which symbolset the entry applies to.  You may
# put "?" if you don't know (or don't care) which symbolset.

# The "MSWord font" is the classification MS Word will use for the font.
# You can specify a specific font number if you want to make sure the font
# is assigned a certain number (for compatibility with existing Word docu-
# ments).  Or you can give a general classification: modern, roman, script,
# foreign, decor, or symbol.  BuildPRD will try to pick a font number in
# that classification.  If you don't care which font number is assigned to
# the font, you can put "?".

# typeface name
#    |               LJ nbr
#    |                  |  symbolset
#    |                  |   |    MSWord font
#    |                  |   |       |
#    v                  v   v       v

LinePrinterPC        (  0, 10U) ->  6
LinePrinter          (  0,  8U) ->  7
Pica                 (  1,   ?) -> modern
Elite                (  2,   ?) ->  2
CourierPC            (  3, 10U) ->  1
Courier              (  3,  8U) ->  0
CourierSymbol        (  3,  0N) -> 63  # ISO 100 Latin 1 (copyright, etc.)
Helvetica            (  4,   ?) ->  8
CGTimes              (  5, 10U) -> 16
TimesRoman           (  5,   ?) -> 24
LetterGothic         (  6,   ?) ->  4
ScriptFont           (  7,   ?) -> 32
Prestige             (  8,   ?) -> modern
Caslon               (  9,   ?) -> roman
Orator               ( 10,   ?) -> 48
Presentation         ( 11,   ?) -> 12
HelvCond             ( 12,   ?) -> modern
Serifa               ( 13,   ?) -> roman
Futura               ( 14,   ?) -> modern
Palatino             ( 15,   ?) -> 26
ITC-Souvenir         ( 16,   ?) -> 27
Optima               ( 17,   ?) -> 19
Garamond             ( 18,   ?) -> 28
CooperBlack          ( 19,   ?) -> 55
Coronet              ( 20,   ?) -> 38
Broadway             ( 21,   ?) -> decor
BauerBodini          ( 22,   ?) -> 30
CenturySchool        ( 23,   ?) -> 25
University           ( 24,   ?) -> 31
HelvOutline          ( 25,   ?) -> modern
FuturaCond           ( 26,   ?) -> modern
ITC-Korinna          ( 27,   ?) -> modern
Arabic               ( 28,   ?) -> foreign
CloisterBlack        ( 29,   ?) -> decor
ITC-Galliard         ( 30,   ?) -> roman
AvantGarde           ( 31,   ?) ->  9
Brush                ( 32,   ?) -> script
Blippo               ( 33,   ?) -> decor
Hobo                 ( 34,   ?) -> decor
Windsor              ( 35,   ?) -> decor
HelvComp             ( 36,   ?) -> modern
HelvExtraCond        ( 37,   ?) -> modern
Peignot              ( 38,   ?) -> decor
Baskerville          ( 39,   ?) -> roman
GaramondCond         ( 40,   ?) -> roman
TradeGothic          ( 41,   ?) -> ?
GoudyOldStyle        ( 42,   ?) -> roman
Zapf-Chancery        ( 43,   ?) -> 50
Clarendon            ( 44,   ?) -> roman
Zapf-Dingbats        ( 45,   ?) -> symbol
Cooper               ( 46,   ?) -> decor
ITC-Bookman          ( 47,   ?) -> roman
Stick                ( 48,   ?) -> decor
HP-GLSpline          ( 49,   ?) -> symbol
HP-GLDrafting        ( 50,   ?) -> symbol
GillSans             ( 51,   ?) -> modern
Univers              ( 52,   ?) ->  3
Bodini               ( 53,   ?) -> 30
Rockwell             ( 54,   ?) -> roman
Melior               ( 55,   ?) -> roman
ITC-Tiffany          ( 56,   ?) -> roman
ITC-Clearface        ( 57,   ?) -> roman
Amelia               ( 58,   ?) -> decor
ParkAvenue           ( 59,   ?) -> 37
HandelGothic         ( 60,   ?) -> modern
DomCasual            ( 61,   ?) -> decor
ITC-Benguiat         ( 62,   ?) -> roman
ITC-Cheltenham       ( 63,   ?) -> roman
CenturyExp           ( 64,   ?) -> roman
FranklinGothic       ( 65,   ?) -> modern
FranklinExpressed    ( 66,   ?) -> modern
FranklinExtCond      ( 67,   ?) -> modern
Plantin              ( 68,   ?) -> ?
TrumpMedieval        ( 69,   ?) -> roman
FuturaBlack          ( 70,   ?) -> modern
Chancelor            ( 72,   ?) -> 50
Broadway             ( 73,   ?) -> 11
Greek                ( 75,   ?) -> foreign
BitstreamCharter     (136,   ?) -> roman




# symbolsets

# These tables map screen characters to corresponding printer characters.

#         PCL code for the symbolset--you can also use the symbolset number
#         |
#         v

symbolset 8U   # Roman-8
          for codepage 437  # U.S.
#                       ^
#                       |
#                       codepage indicates your *screen* font
#                           (this number is the same number used in the
#                           CONFIG.SYS command DISPLAY.SYS CON=(...)
#                           which non-U.S. users might have.  The choices
#                           are: 437 (U.S., default) and
#                                850 (Multilingual)
#                                852 (Slavic)
#                                860 (Portugal)
#                                863 (Canadian-French)
#                                865 (Nordic)
#                           The release version of this file contains only 
#                           codepages 437 and 850.
#                           Support for others may be added in a future
#                           release of this software.  You are welcome to
#                           add your own symbolset mappings to this file.)
#

(

# character you see on the screen
# |
# |    printer character (decimal number)
# |    |
# v    v

'' -> 180
'' -> 207
'' -> 197
'' -> 192
'' -> 204
'' -> 200
'' -> 212
'' -> 181
'' -> 193
'' -> 205
'' -> 201
'' -> 221
'' -> 209
'' -> 217
'' -> 216
'' -> 208
'' -> 220
'' -> 215
'' -> 211
'' -> 194
'' -> 206
'' -> 202
'' -> 195
'' -> 203
'' -> 239
'' -> 218
'' -> 219
'' -> 191
'' -> 187
'' -> 188
'' ->  32  # not in symbolset; map to space
'' -> 190
'' -> 196
'' -> 213
'' -> 198
'' -> 199
'' -> 183
'' -> 182
'' -> 249
'' -> 250
'' -> 185
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 248
'' -> 247
'' -> 184
'' -> 251
'' -> 253
'' -> 127
'' -> 127
'' -> 127
'' -> 124
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45   # bug in Word: always translates to hyphen; want -> 246
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 222
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 254
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 179
'' -> 242
'' -> 242
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 252
)

symbolset 8U           # Roman8
	for codepage 850  # Multilingual
(
'' -> 180
'' -> 207
'' -> 197
'' -> 192
'' -> 204
'' -> 200
'' -> 212
'' -> 181
'' -> 193
'' -> 205
'' -> 201
'' -> 221
'' -> 209
'' -> 217
'' -> 216
'' -> 208
'' -> 220
'' -> 215
'' -> 211
'' -> 194
'' -> 206
'' -> 202
'' -> 195
'' -> 203
'' -> 239
'' -> 218
'' -> 219
'' -> 214
'' -> 187
'' -> 210
'' -> 120
'' -> 190
'' -> 196
'' -> 213
'' -> 198
'' -> 199
'' -> 183
'' -> 182
'' -> 249
'' -> 250
'' -> 185
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 248
'' -> 247
'' -> 184
'' -> 251
'' -> 253
'' -> 127
'' -> 127
'' -> 127
'' -> 124
'' ->  32  # not in symbolset; map to space
'' -> 224
'' -> 162
'' -> 161
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 191
'' -> 188
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45
'' ->  32  # not in symbolset; map to space
'' -> 226
'' -> 225
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 186
'' -> 228
'' -> 227
'' -> 164
'' -> 165
'' -> 163
'' ->  32  # not in symbolset; map to space
'' -> 229
'' -> 166
'' -> 167
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 252
'' ->  32  # not in symbolset; map to space
'' -> 230
'' ->  32  # not in symbolset; map to space
'' -> 231
'' -> 222
'' -> 223
'' -> 232
'' -> 234
'' -> 233
'' -> 243
'' -> 241
'' -> 240
'' -> 237
'' -> 174
'' -> 173
'' -> 178
'' -> 177
'' -> 176
'' -> 168
'' -> 246
'' -> 254
'' ->  32  # not in symbolset; map to space
'' -> 245
'' -> 244
'' -> 189
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 179
'' -> 171
'' -> 242
'' ->  49
'' ->  51
'' ->  50
'' -> 252
)

symbolset 10U  # IBM PC
		for codepage 850
(
'' -> 237
'' -> 156
'' -> 237  # use lowercase version
'' ->  32  # not in symbolset; map to space
'' -> 159
'' ->  32  # not in symbolset; map to space
'' -> 170
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 185
'' -> 186
'' -> 187
'' -> 188
'' -> 155
'' -> 157
'' -> 191
'' -> 192
'' -> 193
'' -> 194
'' -> 195
'' -> 196
'' -> 197
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 200
'' -> 201
'' -> 202
'' -> 203
'' -> 204
'' -> 205
'' -> 206
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 217
'' -> 218
'' -> 219
'' -> 220
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 223
'' ->  32  # not in symbolset; map to space
'' -> 225
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 230
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 196  # ?
'' -> 241
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  20
'' ->  21
'' -> 246
'' ->  32  # not in symbolset; map to space
'' -> 248
'' ->  32  # not in symbolset; map to space
'' -> 250
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 253
'' -> 254
)

symbolset 309  # ANSI (Windows)
          for codepage 437
(
''' -> 146  # interchange straight and curved single quotes
'`' -> 145
'' -> 163
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 170
'' -> 186
'' -> 191
'' ->  32  # not in symbolset; map to space
'' -> 189
'' -> 188
'' -> 161
'' -> 171
'' -> 187
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 196
'' -> 197
'' -> 198
'' -> 224
'' -> 225
'' -> 226
'' -> 228
'' -> 229
'' -> 230
'' -> 199
'' -> 231
'' -> 201
'' -> 233
'' -> 234
'' -> 235
'' -> 232
'' -> 181
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 239
'' -> 238
'' -> 236
'' -> 237
'' -> 209
'' -> 241
'' -> 169  # not in symbolset; map to copyright symbol
'' ->  32  # not in symbolset; map to space
'' -> 165
'' ->  32  # not in symbolset; map to space  
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 162
'' -> 214
'' -> 242
'' -> 243
'' -> 244
'' -> 246
'' -> 223
'' ->  32  # not in symbolset; map to space
'' -> 174  # not in symbolset; map to registered symbol
'' -> 220
'' ->  32  # not in symbolset; map to space
'' -> 249
'' -> 250
'' -> 251
'' -> 252
'' -> 248
'' ->  32  # not in symbolset; map to space
'' -> 255
'' -> 164  # not in symbolset; map to "sun" symbol
'' ->  32  # not in symbolset; map to space
'' -> 172
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 124
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45   # bug in Word: always translates to hyphen; want -> 246
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 177
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 176
'' -> 183
'' ->  32  # not in symbolset; map to space 
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 178
'' ->  32 
)

symbolset 309  # ANSI (Windows)
          for codepage 850
(
''' -> 146    # interchange straight and curved single quotes
'`' -> 145
'' -> 45  # shouldn't need this but ...
'' -> 199
'' -> 252
'' -> 233
'' -> 226
'' -> 228
'' -> 224
'' -> 229
'' -> 231
'' -> 234
'' -> 235
'' -> 232
'' -> 239
'' -> 238
'' -> 236
'' -> 196
'' -> 197
'' -> 201
'' -> 230
'' -> 198
'' -> 244
'' -> 246
'' -> 242
'' -> 251
'' -> 249
'' -> 255
'' -> 214
'' -> 220
'' -> 248
'' -> 163
'' -> 216
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 225
'' -> 237
'' -> 243
'' -> 250
'' -> 241
'' -> 209
'' -> 170
'' -> 186
'' -> 191
'' -> 174
'' -> 172
'' -> 189
'' -> 188
'' -> 161
'' -> 171
'' -> 187
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 124
'' ->  32  # not in symbolset; map to space
'' -> 193
'' -> 194
'' -> 192
'' -> 169
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 162
'' -> 165
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45  # bug in Word: always translates to hyphen; want -> 246
'' ->  32  # not in symbolset; map to space
'' -> 227
'' -> 195
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 164
'' -> 240
'' -> 208
'' -> 202
'' -> 203
'' -> 200
'' ->  32  # not in symbolset; map to space
'' -> 205
'' -> 206
'' -> 207
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 166
'' -> 204
'' ->  32  # not in symbolset; map to space
'' -> 211
'' -> 223
'' -> 212
'' -> 210
'' -> 245
'' -> 213
'' -> 181
'' -> 254
'' -> 222
'' -> 218
'' -> 219
'' -> 217
'' -> 253
'' -> 221
'' -> 175
'' -> 180
'' -> 173
'' -> 177
'' ->  32  # not in symbolset; map to space
'' -> 190
'' -> 182
'' -> 167
'' ->  32  # not in symbolset; map to space
'' -> 184
'' -> 176
'' -> 168
'' -> 183 
'' -> 185
'' -> 179
'' -> 178
'' ->  32  # not in symbolset; map to space
)

symbolset 0N # ISO 100: ECMA-94 (Latin 1)
          for codepage 437
(
'' -> 199
'' -> 252
'' -> 233
'' -> 226
'' -> 228
'' -> 224
'' -> 229
'' -> 231
'' -> 234
'' -> 235
'' -> 232
'' -> 239
'' -> 238
'' -> 236
'' -> 196
'' -> 197
'' -> 201
'' -> 230
'' -> 198
'' -> 244
'' -> 246
'' -> 242
'' -> 251
'' -> 249
'' -> 255
'' -> 214
'' -> 220
'' -> 162
'' -> 163
'' -> 165
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 225
'' -> 237
'' -> 243
'' -> 250
'' -> 241
'' -> 209
'' -> 170
'' -> 186
'' -> 191
'' ->  32  # not in symbolset; map to space
'' -> 172
'' -> 189
'' -> 188
'' -> 161
'' -> 171
'' -> 187
'' -> 127
'' -> 127
'' -> 127
'' -> 166
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45   # bug in Word: always translates to hyphen; want -> 246
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 223
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 169  # not in symbolset; map to copyright symbol
'' -> 181
'' ->  32  # not in symbolset; map to space
'' -> 164  # not in symbolset; map to "sun" symbol
'' -> 174  # not in symbolset; map to registered symbol
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 248
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 177
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 247
'' ->  32  # not in symbolset; map to space
'' -> 176
'' -> 183
'' ->  32  # not in symbolset; map to space 
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 178
'' ->  32  # not in symbolset; map to space
)

symbolset 0N # ISO 100: ECMA-94 (Latin 1)
          for codepage 850
(
'' -> 199
'' -> 252
'' -> 233
'' -> 226
'' -> 228
'' -> 224
'' -> 229
'' -> 231
'' -> 234
'' -> 235
'' -> 232
'' -> 239
'' -> 238
'' -> 236
'' -> 196
'' -> 197
'' -> 201
'' -> 230
'' -> 198
'' -> 244
'' -> 246
'' -> 242
'' -> 251
'' -> 249
'' -> 255
'' -> 214
'' -> 220
'' -> 248
'' -> 163
'' -> 216
'' -> 215
'' ->  32  # not in symbolset; map to space
'' -> 225
'' -> 237
'' -> 243
'' -> 250
'' -> 241
'' -> 209
'' -> 170
'' -> 186
'' -> 191
'' -> 174
'' -> 172
'' -> 189
'' -> 188
'' -> 161
'' -> 171
'' -> 187
'' -> 127
'' -> 127
'' -> 127
'' -> 166
'' ->  32  # not in symbolset; map to space
'' -> 193
'' -> 194
'' -> 192
'' -> 169
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 162
'' -> 165
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  45  # bug in Word: always translates to hyphen; want -> 246
'' ->  32  # not in symbolset; map to space
'' -> 227
'' -> 195
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 164
'' -> 240
'' -> 208
'' -> 202
'' -> 203
'' -> 200
'' ->  32  # not in symbolset; map to space
'' -> 205
'' -> 206
'' -> 207
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' ->  32  # not in symbolset; map to space
'' -> 166
'' -> 204
'' ->  32  # not in symbolset; map to space
'' -> 211
'' -> 223
'' -> 212
'' -> 210
'' -> 245
'' -> 213
'' -> 181
'' -> 254
'' -> 222
'' -> 218
'' -> 219
'' -> 217
'' -> 253
'' -> 221
'' -> 175
'' -> 180
'' -> 173
'' -> 177
'' ->  32  # not in symbolset; map to space
'' -> 190
'' -> 182
'' -> 167
'' -> 247
'' -> 184
'' -> 176
'' -> 168
'' -> 183 
'' -> 185
'' -> 179
'' -> 178
'' ->  32  # not in symbolset; map to space
)

