	TITLE	GSPPT - 320x200x16 mode support
	NAME	GSPPT


	COMMENT	$

	Name:		GSPPT

		Written and (c) by Dave Stampe 9/11/91
		Not for commercial use, so get permission
		before marketing code using this stuff!
		For private PD use only.

		$

		.MODEL tiny farstack
		.CODE

 ;
 ; void vsync();		/* waits for vert. sync pulse */
 ;
		PUBLIC	_vsync

_vsync	proc	far

	push	bp
	mov	bp,sp
	mov		dx,03DAh
	in		al,dx		; test if 0
	test		al,8
	je	short @11@218
@11@122:
	in		al,dx
	nop
	test		al,8            ; wait for 0
	jne	short @11@122
@11@218:
	in		al,dx
	nop
	test		al,8            ; wait for 1
	je	short @11@218
	pop	bp
	ret

_vsync	endp

 ;
 ; void setup_hdwe(int mode);	/* sets up VGA for line, poly draw */
 ;                              /* modes are: 0=PUT, 1=OR,         */
 ;				/*	      2=AND, 3=XOR         */

		PUBLIC	_setup_hdwe

_setup_hdwe	proc	far

	push	bp
	mov	bp,sp
	mov	dx,03CEH
	mov	ah,BYTE PTR [bp+6]      ; set write logic mode
	sal	ah,1
	sal	ah,1
	sal	ah,1
	mov	al,03h
	out	dx,ax
	mov	ax,0B05h                ; write mode = 3 (CPU byte is mask)
	out	dx,ax
	mov	ax,0007h                ; setup for FFh returned by read
	out	dx,ax
	mov	ax,0FF08h               ; all bits enabled
	out	dx,ax
	mov	ax,0FF01h
	out	dx,ax
	pop	bp
	ret

_setup_hdwe	endp

 ;
 ; void reset_hdwe()
 ;

		PUBLIC	_reset_hdwe

_reset_hdwe	proc	far

	push	bp
	mov	bp,sp
	mov	dx,03CEH
	mov	ax,0000         ; reset VGA to mode BIOS expects
	out	dx,ax
	mov	ax,0001
	out	dx,ax
	mov	ax,0003
	out	dx,ax
	mov	ax,0005
	out	dx,ax
	pop	bp
	ret

_reset_hdwe	endp

 ;
 ; int clr_page(int page, int color);	/* clear page to color */
 ;
 ;  /* returns 0 if OK, 1 if bad page */

		PUBLIC	_clr_page

_clr_page	proc	far

	push	bp
	mov	bp,sp
	dec	sp
	dec	sp
	push	di
	mov	ax,word ptr [bp+6]      ; compute page addr
	mov	cl,13
	shl	ax,cl
	mov	word ptr [bp-2],ax
	cmp	word ptr [bp+6],7       ; check for valid page
	jle	short @14@74
	mov	ax,65535
	jmp	short @14@482
@14@74:
	call	far ptr _reset_hdwe     ; reset to default VGA mode
	cld
	mov	dx,03CEh
	mov	al,0              	; set write color
	mov	ah,BYTE PTR [bp+8]
	and	ah,15
	out	dx,ax
	mov	ax,0F01h
	out	dx,ax
	mov	ax,0A000h
	mov	es,ax
	mov	cx,4000
	mov	al,[bp+8]               ; write pageful of color (8K)
	mov	di,[bp-2]
	rep	stosw
	mov	ax,0001h                ; reset VGA mode
	out	dx,ax
	xor	ax,ax
@14@482:
	pop	di
	mov	sp,bp
	pop	bp
	ret

_clr_page	endp

   ;
   ;	int copy_page(int source, int dest)
   ;
   ;	/* returns 0 if OK, 1 if bad page */

		PUBLIC	_copy_page

_copy_page	proc	far

	push	bp
	mov	bp,sp
	sub	sp,4
	push	si
	push	di
	mov	ax,word ptr [bp+6]    	; compute source address
	mov	cl,13
	shl	ax,cl
	mov	word ptr [bp-2],ax
	mov	ax,word ptr [bp+8]	; compute dest. address
	shl	ax,cl
	mov	word ptr [bp-4],ax
	cmp	word ptr [bp+6],7
	jg	short @15@74            ; check for valid page #'s
	cmp	word ptr [bp+8],7
	jle	short @15@98
@15@74:
	mov	ax,65535
	jmp	short @15@506
@15@98:
	call	far ptr _reset_hdwe     ; default VGA state
	push	ds
	cld
	mov	dx,03CEh              	; read mode 0, write mode 1 (copy)
	mov	ax,0105h
	out	dx,ax
	mov	ax,0A000h
	mov	es,ax
	mov	ds,ax
	mov	cx,8000
	mov	si,[bp-2]
	mov	di,[bp-4]
	rep	movsb                   ; copy whole page (8K)
	mov	ax,0005h
	out	dx,ax
	pop	ds
	xor	ax,ax
@15@506:
	pop	di
	pop	si
	mov	sp,bp
	pop	bp
	ret

_copy_page	endp


 ;
 ; void vga_reg(int reg) 	/* integer: lsby=reg(0=color), msby=value */
 ;

		PUBLIC	_vga_reg

_vga_reg	proc	far

	push	bp
	mov	bp,sp
	mov	dx,03CEH
	mov	ax,WORD PTR [bp+6]
	out	dx,ax
	pop	bp
	ret

_vga_reg	endp



 ;
 ; void load_color(int color)    /* integer: color reg. load */
 ;

		PUBLIC	_load_color

_load_color	proc	far

	push	bp
	mov	bp,sp
	mov	dx,03CEH
	xor	al,al
	mov	ah,BYTE PTR [bp+6]
	and	ah,15
	out	dx,ax
	pop	bp
	ret

_load_color	endp


 ;
 ; void _set_vmode(int mode)    /* enters video mode thru BIOS */
 ;

		PUBLIC	_set_vmode

_set_vmode	proc	far

	push	bp
	mov	bp,sp
	mov	ah,0
	mov	al,BYTE PTR [bp+6]
	int	10h
	pop	bp
	ret

_set_vmode	endp


 ;
 ; void _set_vpage(int page)    /* sets video page thru BIOS */
 ;

		PUBLIC	_set_vpage

_set_vpage	proc	far

	push	bp
	mov	bp,sp
	push	si
	push	di
	push	cx
	push	dx
	mov	al,BYTE PTR [bp+6]
	xor	ah,ah
	cmp	al,8		; check page #
	jae	badpage

	shl	ax,13

	mov	bh,ah
	mov	ah,al           ; page # -> address
	mov	al,0dh
	mov	bl,0ch

	mov	dx,03d4h        ; set CRTC address
	out	dx,ax
	mov	ax,bx
	out	dx,ax
badpage:
	pop	dx
	pop	cx
	pop	di
	pop	si
	pop	bp
	ret

_set_vpage	endp


xchar	equ	[bp+6]          ; arguments to _xprintc

	extrn	_dpaddr		; page base address
	extrn	_xcpline	; line to print on
	extrn	_xcpcol		; column to print on

   ;
   ;	xprintc(int character)
   ;

		PUBLIC	_xprintc

_xprintc	proc	far

	.386

	push	bp
	mov	bp,sp

	push	ds
	push	di
	push	si

	mov	ax,0a000h
	mov	es,ax

	mov	ax,WORD PTR _xcpline       ; setup video address
	imul	ax,40
	mov	bx,WORD PTR _xcpcol
	shr	bx,3
	add	ax,bx
	add	ax,WORD PTR _dpaddr
	mov	di,ax

	xor	ah,ah
	mov     al,xchar
	shl	ax,3

	mov	cx,WORD PTR _xcpcol
	and	cx,7

	xor	bx,bx
	mov	ds,bx
	mov	bx,43h*4
	lds	si,ds:[bx]
	add     si,ax

	mov	bx,8

nxtline:
	mov	ah,ds:[si]      	; 8 pixels
	xor	al,al
	shr	ax,cl
	and	es:[di],ah
	and	es:[di+1],al

	inc	si
	add	di,40
	dec	bx
	jnz	nxtline

	pop	si
	pop	di
	pop	ds

	pop	bp
	ret

_xprintc	endp


bytrev:	db	000h,080h,040h,0c0h,020h,0a0h,060h,0e0h,010h,090h,050h,0d0h,030h,0b0h,070h,0f0h
	db	008h,088h,048h,0c8h,028h,0a8h,068h,0e8h,018h,098h,058h,0d8h,038h,0b8h,078h,0f8h
	db	004h,084h,044h,0c4h,024h,0a4h,064h,0e4h,014h,094h,054h,0d4h,034h,0b4h,074h,0f4h
	db	00ch,08ch,04ch,0cch,02ch,0ach,06ch,0ech,01ch,09ch,05ch,0dch,03ch,0bch,07ch,0fch
	db	002h,082h,042h,0c2h,022h,0a2h,062h,0e2h,012h,092h,052h,0d2h,032h,0b2h,072h,0f2h
	db	00ah,08ah,04ah,0cah,02ah,0aah,06ah,0eah,01ah,09ah,05ah,0dah,03ah,0bah,07ah,0fah
	db	006h,086h,046h,0c6h,026h,0a6h,066h,0e6h,016h,096h,056h,0d6h,036h,0b6h,076h,0f6h
	db	00eh,08eh,04eh,0ceh,02eh,0aeh,06eh,0eeh,01eh,09eh,05eh,0deh,03eh,0beh,07eh,0feh
	db	001h,081h,041h,0c1h,021h,0a1h,061h,0e1h,011h,091h,051h,0d1h,031h,0b1h,071h,0f1h
	db	009h,089h,049h,0c9h,029h,0a9h,069h,0e9h,019h,099h,059h,0d9h,039h,0b9h,079h,0f9h
	db	005h,085h,045h,0c5h,025h,0a5h,065h,0e5h,015h,095h,055h,0d5h,035h,0b5h,075h,0f5h
	db	00dh,08dh,04dh,0cdh,02dh,0adh,06dh,0edh,01dh,09dh,05dh,0ddh,03dh,0bdh,07dh,0fdh
	db	003h,083h,043h,0c3h,023h,0a3h,063h,0e3h,013h,093h,053h,0d3h,033h,0b3h,073h,0f3h
	db	00bh,08bh,04bh,0cbh,02bh,0abh,06bh,0ebh,01bh,09bh,05bh,0dbh,03bh,0bbh,07bh,0fbh
	db	007h,087h,047h,0c7h,027h,0a7h,067h,0e7h,017h,097h,057h,0d7h,037h,0b7h,077h,0f7h
	db	00fh,08fh,04fh,0cfh,02fh,0afh,06fh,0efh,01fh,09fh,05fh,0dfh,03fh,0bfh,07fh,0ffh

xchar	equ	[bp+6]          ; arguments to _xprintc


   ;
   ;	xrprintc(int character) ; print flipped
   ;

		PUBLIC	_xrprintc

_xrprintc	proc	far

	.386

	push	bp
	mov	bp,sp

	push	ds
	push	di
	push	si

	mov	ax,0a000h
	mov	es,ax

	mov	ax,WORD PTR _xcpline       ; setup video address
	imul	ax,40
	mov	bx,WORD PTR _xcpcol
	shr	bx,3
	add	ax,bx
	dec	bx			; so that it's at start of rightmost chr
	add	ax,WORD PTR _dpaddr
	mov	di,ax

	xor	ah,ah
	mov     al,xchar
	shl	ax,3

	mov	cx,WORD PTR _xcpcol
	and	cx,7

	xor	bx,bx
	mov	ds,bx
	mov	bx,43h*4
	lds	si,ds:[bx]
	add     si,ax

	mov	dx,8

rnxtline:
	mov	bl,ds:[si]      		; 8 pixels
	xor	bh,bh
	mov	ah,BYTE PTR cs:bytrev[bx]	; lookup reversed version
	xor	al,al
	shr	ax,cl
	and	es:[di],ah
	and	es:[di+1],al

	inc	si
	add	di,40
	dec	dx
	jnz	rnxtline

	pop	si
	pop	di
	pop	ds

	pop	bp
	ret

_xrprintc	endp



 ;
 ; int save_8x8(int h, int y, int buffer, int address); /* save 8x8 at x,y */
 ;     							/* returns address */
		PUBLIC	_save_8x8

xcoord equ [bp+6]
ycoord equ [bp+8]
buffer equ [bp+10]

_save_8x8	proc	far

	push	bp
	mov	bp,sp
	push	di
	push	si
	push	cx

	mov	ax,ycoord
	imul	ax,40
	mov	si,xcoord
	shr	si,3
	add	si,ax
	add	si,WORD PTR _dpaddr
	push	si

	mov	di,0fe00h	; temp. buffer
	mov	ax,buffer
	shl	ax,5
	add	di,ax

	mov	ax,0A000h
	mov	es,ax
	mov	cx,8

nxsl:	mov	al,es:[si]      ; move 16 so it always does 8
	mov	BYTE PTR es:[di],0
	mov	al,es:[si+1]
	mov	BYTE PTR es:[di+1],0
	add	si,40
	add	di,2
	loop	nxsl

	pop	ax
	pop	cx
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	ret

_save_8x8	endp

 ;
 ; void rest_8x8(int buffer, int address);	/* restore 8x8 at x,y */
 ;
		PUBLIC	_rest_8x8

buffer  equ [bp+6]
address equ [bp+8]

_rest_8x8	proc	far

	push	bp
	mov	bp,sp
	push	di
	push	si
	push	cx

	mov	di,address

	mov	si,0fe00h	; temp. buffer
	mov	ax,buffer
	shl	ax,5
	add	si,ax
	mov	ax,0A000h
	mov	es,ax
	mov	cx,8

nxrl:	mov	al,es:[si]      ; move 16 so it always does 8
	mov	BYTE PTR es:[di],0
	mov	al,es:[si+1]
	mov	BYTE PTR es:[di+1],0
	add	si,2
	add	di,40
	loop	nxrl

	pop	cx
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	ret

_rest_8x8	endp



 ;
 ; int clr_block(int l, int t, int r, int b, int page, int color);
 ;
 ;  /* returns 0 if OK, 1 if bad page */

cbl     equ WORD PTR [bp+6]
cbt     equ WORD PTR [bp+8]
cbr     equ WORD PTR [bp+10]
cbb     equ WORD PTR [bp+12]
cbpage  equ WORD PTR [bp+14]
cbcolor equ BYTE PTR [bp+16]

		PUBLIC	_clr_block

_clr_block	proc	far

	push	bp
	mov	bp,sp
	push	di
	push	cx
	cld

	call	far ptr _reset_hdwe     ; reset to default VGA mode

	mov	ax,0F01h               ; setup for big writes
	out	dx,ax
	mov	ax,0A000h
	mov	es,ax

	mov	dx,03CEH		; load color
	xor	al,al
	mov	ah,cbcolor
	and	ah,15
	out	dx,ax

	mov     ax,cbpage              ; compute page
	shl	ax,13
	mov	di,ax

	mov	bx,cbb
	sub	bx,cbt			; bx = line count
	jb	badcb

	mov	ax,cbt
	imul    ax,40
	add	di,ax
	mov	ax,cbl
	shr	ax,3
	add	di,ax			; start address

	mov	cx,cbl
	and	cx,0FFF8h
	sub	cx,cbr
	neg	cx
	js      badcb
	shr	cx,3
	inc	cx
	mov	ax,cx			; count per line
	sub	cx,40
	neg	cx
	mov	dx,cx			; fixup factor

cbloop:	mov	cx,ax
	rep	stosb
	add	di,dx
	dec	bx
	jge	cbloop

	mov	ax,0001h                ; reset VGA mode
	out	dx,ax
	xor	ax,ax
	jmp	cbexit

badcb:	mov	ax,-1

cbexit:	pop	cx
	pop	di
	mov	sp,bp
	pop	bp
	ret


_clr_block	endp

   ;
   ;	int copy_block(int spage, int sx, int sy,
   ;		       int dpage, int dx, int dy,
   ;		       int xsize, int vsize )
   ;
   ;	/* returns 0 if OK, 1 if bad page */

copsp    equ WORD PTR [bp+6]
copsx    equ WORD PTR [bp+8]
copsy    equ WORD PTR [bp+10]
copdp    equ WORD PTR [bp+12]
copdx    equ WORD PTR [bp+14]
copdy    equ WORD PTR [bp+16]
copxs    equ WORD PTR [bp+18]
copys    equ WORD PTR [bp+20]

		PUBLIC	_copy_block

_copy_block	proc	far

	push	bp
	mov	bp,sp
	sub	sp,4
	push	si
	push	di
	push	cx

	call	far ptr _reset_hdwe     ; write VGA state
	push	ds
	cld
	mov	dx,03CEh              	; read mode 0, write mode 1 (copy)
	mov	ax,0105h
	out	dx,ax
	mov	ax,0A000h
	mov	es,ax
	mov	ds,ax
	mov	ax,copsp	    	; compute source address
	shl	ax,13
	mov	si,ax
	mov	ax,copdp		; compute dest. address
	shl	ax,13
	mov	di,ax

	mov	bx,copys                ; bx = line count

	mov	ax,copsy
	imul    ax,40
	add	si,ax
	mov	ax,copsx
	shr	ax,3
	add	si,ax			; start address

	mov	ax,copdy
	imul    ax,40
	add	di,ax
	mov	ax,copdx
	shr	ax,3
	add	di,ax			; start address

	mov	cx,copxs
	add	cx,7
	shr	cx,3
	inc	cx
	mov	ax,cx			; count per line
	sub	cx,40
	neg	cx
	mov	dx,cx			; fixup factor

coplop:	mov	cx,ax
	rep	movsb
	add	si,dx
	add	di,dx
	dec	bx
	jg	coplop

	mov	ax,0005h
	out	dx,ax
	pop	ds
	xor	ax,ax

	pop	cx
	pop	di
	pop	si
	mov	sp,bp
	pop	bp
	ret

_copy_block	endp


 ;
 ; void load_DAC(char far *data, int count);
 ;			/* loads DAC             */


 count   equ [bp+10]
 dacdata equ [bp+6]

	PUBLIC	_load_DAC

		; maps DAC load for std. palette reg. set

pal_map: db 	0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63,0


_load_DAC  	proc	far

	push	bp
	mov	bp,sp
	push	dx
	push	cx
	push	si

	mov	ax,cs
	mov	es,ax
	mov     dx,offset pal_map
	mov	ax,1009h
	int	10h

	les	bx,DWORD PTR dacdata
	mov	si,offset pal_map
	mov     cx,WORD PTR count

mvp:	mov	al,BYTE PTR cs:[si]
	inc	si
	mov	dx,03C8h
	out	dx,al

	mov	dx,03C9h

	mov 	al,BYTE PTR es:[bx]
	out	dx,al
	inc	bx
	nop
	nop
	mov 	al,BYTE PTR es:[bx]
	out	dx,al
	inc	bx
	nop
	nop
	mov 	al,BYTE PTR es:[bx]
	out	dx,al
	inc	bx
	loop	mvp

	pop	si
	pop	cx
	pop	dx
	pop	bp
	ret

_load_DAC	endp

 ;
 ; void read_DAC(char far *data, int count);
 ;			/* reads DAC             */


 count   equ [bp+10]
 dacdata equ [bp+6]

	PUBLIC	_read_DAC

_read_DAC  	proc	far

	push	bp
	mov	bp,sp
	push	dx
	push	cx
	push	si

	mov	ax,cs
	mov	es,ax
	mov     dx,offset pal_map
	mov	ax,1009h
	int	10h

	les	bx,DWORD PTR dacdata
	mov	si,offset pal_map
	mov     cx,WORD PTR count

mvpr:	mov	al,BYTE PTR cs:[si]
	inc	si
	mov	dx,03C7h
	out	dx,al

	mov	dx,03C9h

	in	al,dx
	mov 	BYTE PTR es:[bx],al
	inc	bx
	nop
	nop
	in	al,dx
	mov 	BYTE PTR es:[bx],al
	inc	bx
	nop
	nop
	in	al,dx
	mov 	BYTE PTR es:[bx],al
	inc	bx
	loop	mvpr

	pop	si
	pop	cx
	pop	dx
	pop	bp
	ret

_read_DAC	endp


		end


